"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from ascend_sdk import utils
from ascend_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from ascend_sdk.utils import validate_open_enum
from enum import Enum
from pydantic import model_serializer
from pydantic.functional_validators import PlainValidator
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class BookingFeeAmountTypedDict(TypedDict):
    r"""The fee amount. Not required if the fee is suppressed"""

    value: NotRequired[str]
    r"""The decimal value, as a string; Refer to [Google’s Decimal type protocol buffer](https://github.com/googleapis/googleapis/blob/40203ca1880849480bbff7b8715491060bbccdf1/google/type/decimal.proto#L33) for details"""


class BookingFeeAmount(BaseModel):
    r"""The fee amount. Not required if the fee is suppressed"""

    value: Optional[str] = None
    r"""The decimal value, as a string; Refer to [Google’s Decimal type protocol buffer](https://github.com/googleapis/googleapis/blob/40203ca1880849480bbff7b8715491060bbccdf1/google/type/decimal.proto#L33) for details"""


class BookingFeeType(str, Enum, metaclass=utils.OpenEnumMeta):
    r"""The type of fee"""

    FEE_TYPE_UNSPECIFIED = "FEE_TYPE_UNSPECIFIED"
    CLIENT_CLEARING = "CLIENT_CLEARING"
    LIQUIDITY = "LIQUIDITY"
    TRADE_ACTIVITY = "TRADE_ACTIVITY"
    FINANCIAL_TRANSACTION_TAX = "FINANCIAL_TRANSACTION_TAX"
    INDEX_OPTION_FEE = "INDEX_OPTION_FEE"
    SEC_FEE = "SEC_FEE"
    OPTIONS_REGULATORY = "OPTIONS_REGULATORY"
    GENERAL_PURPOSE_FEE = "GENERAL_PURPOSE_FEE"
    BROKER_FEE = "BROKER_FEE"
    CONTRACT_FEE = "CONTRACT_FEE"
    OCC_FEE = "OCC_FEE"


class BookingFeeTypedDict(TypedDict):
    r"""Fee message includes both fee type as well as the fee amount"""

    amount: NotRequired[Nullable[BookingFeeAmountTypedDict]]
    r"""The fee amount. Not required if the fee is suppressed"""
    suppress_fee: NotRequired[bool]
    r"""Indicates whether to explicitly suppress this fee type. If the trade would normally calculate fees (e.g., for TRADE_ACTIVITY), the client can add a fee with this boolean value set to true, and the Booking Service will not calculate or assess that fee on the trade."""
    type: NotRequired[BookingFeeType]
    r"""The type of fee"""


class BookingFee(BaseModel):
    r"""Fee message includes both fee type as well as the fee amount"""

    amount: OptionalNullable[BookingFeeAmount] = UNSET
    r"""The fee amount. Not required if the fee is suppressed"""

    suppress_fee: Optional[bool] = None
    r"""Indicates whether to explicitly suppress this fee type. If the trade would normally calculate fees (e.g., for TRADE_ACTIVITY), the client can add a fee with this boolean value set to true, and the Booking Service will not calculate or assess that fee on the trade."""

    type: Annotated[
        Optional[BookingFeeType], PlainValidator(validate_open_enum(False))
    ] = None
    r"""The type of fee"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["amount", "suppress_fee", "type"]
        nullable_fields = ["amount"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
