"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from ascend_sdk import utils
from ascend_sdk.types import BaseModel
from ascend_sdk.utils import validate_open_enum
from enum import Enum
from pydantic.functional_validators import PlainValidator
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class IdentityIdentificationType(str, Enum, metaclass=utils.OpenEnumMeta):
    r"""**Field Dependencies:**

    An SSN or ITIN is required when `check_types` is `DATABASE`

    Required if `check_types` is `DATABASE`.

    Otherwise, must be empty.
    """

    TYPE_UNSPECIFIED = "TYPE_UNSPECIFIED"
    SSN = "SSN"
    PASSPORT = "PASSPORT"
    DRIVERS_LICENSE = "DRIVERS_LICENSE"
    ITIN = "ITIN"


class IdentityIdentificationTypedDict(TypedDict):
    r"""stores various identification types"""

    administrative_area: NotRequired[str]
    r"""Administrative area that issued the identification"""
    region_code: NotRequired[str]
    r"""**Field Dependencies:**

    A US identification `region_code` is required when the `check_types` is `DATABASE`

    Required if `check_types` is `DATABASE`.

    Otherwise, must be empty.
    """
    type: NotRequired[IdentityIdentificationType]
    r"""**Field Dependencies:**

    An SSN or ITIN is required when `check_types` is `DATABASE`

    Required if `check_types` is `DATABASE`.

    Otherwise, must be empty.
    """
    value: NotRequired[str]
    r"""**Field Dependencies:**

    An identification value is required when the `check_types` is `DATABASE`

    Required if `check_types` is `DATABASE`.

    Otherwise, must be empty.
    """


class IdentityIdentification(BaseModel):
    r"""stores various identification types"""

    administrative_area: Optional[str] = None
    r"""Administrative area that issued the identification"""

    region_code: Optional[str] = None
    r"""**Field Dependencies:**

    A US identification `region_code` is required when the `check_types` is `DATABASE`

    Required if `check_types` is `DATABASE`.

    Otherwise, must be empty.
    """

    type: Annotated[
        Optional[IdentityIdentificationType], PlainValidator(validate_open_enum(False))
    ] = None
    r"""**Field Dependencies:**

    An SSN or ITIN is required when `check_types` is `DATABASE`

    Required if `check_types` is `DATABASE`.

    Otherwise, must be empty.
    """

    value: Optional[str] = None
    r"""**Field Dependencies:**

    An identification value is required when the `check_types` is `DATABASE`

    Required if `check_types` is `DATABASE`.

    Otherwise, must be empty.
    """
